moDrawWarnings = {};

function moDrawWarnings.setAll(self, name, warning, blinkPos1, blinkPos2, slot)	
	if tonumber(warning) == 0 and moGuiMiniPDAsetGet.warningFirst then
		moSetGetGui["warning0"]:setPosition(moGuiMiniPDAsetGet.posX+(moGuiMiniPDAsetGet.horizontal*slot), moGuiMiniPDAsetGet.posY-(moGuiMiniPDAsetGet.vertical*slot));
		moSetGetGui["warning0"]:render();
		return;
	elseif tonumber(warning) == 1 then
		moSetGetGui["warning1"]:setPosition(moGuiMiniPDAsetGet.posX+(moGuiMiniPDAsetGet.horizontal*slot), moGuiMiniPDAsetGet.posY-(moGuiMiniPDAsetGet.vertical*slot));
		moSetGetGui["warning1"]:render();		
		return;
	elseif tonumber(warning) == 2 then
		moSetGetGui["warning2"]:setPosition(moGuiMiniPDAsetGet.posX+(moGuiMiniPDAsetGet.horizontal*slot), moGuiMiniPDAsetGet.posY-(moGuiMiniPDAsetGet.vertical*slot));
		moSetGetGui["warning2"]:render();		
		return;
	elseif tonumber(warning) == 3 then
		moSetGetGui["warning3"]:setPosition(moGuiMiniPDAsetGet.posX+(moGuiMiniPDAsetGet.horizontal*slot), moGuiMiniPDAsetGet.posY-(moGuiMiniPDAsetGet.vertical*slot));
		moSetGetGui["warning3"]:render();		
		return;
	elseif tonumber(warning) == 4 then
		if not moGuiMiniPDAsetGet.warningBlink then
			moSetGetGui["warning4"]:setPosition(moGuiMiniPDAsetGet.posX+(moGuiMiniPDAsetGet.horizontal*slot), moGuiMiniPDAsetGet.posY-(moGuiMiniPDAsetGet.vertical*slot));
			moSetGetGui["warning4"]:render();
			return;
		end;
		--all warnings identical--
		local identical = 0;
		for a=1, table.getn(moGuiMiniPDAsetGet.warningsTime) do
			if moGuiMiniPDAsetGet.warningsTime[a] > identical then identical = moGuiMiniPDAsetGet.warningsTime[a];end;
		end;
		moGuiMiniPDAsetGet.warningsTime[slot] = identical;
		--all warnings identical--
		if moGuiMiniPDAsetGet.warningsTime[slot] < moGuiMiniPDAsetGet.warningBlinkTime then
			moSetGetGui["warning4"]:setPosition(moGuiMiniPDAsetGet.posX+(moGuiMiniPDAsetGet.horizontal*slot), moGuiMiniPDAsetGet.posY-(moGuiMiniPDAsetGet.vertical*slot));
			moSetGetGui["warning4"]:render();
			moGuiMiniPDAsetGet.warningsTime[slot] = moGuiMiniPDAsetGet.warningsTime[slot]+1;
		else
			if moGuiMiniPDAsetGet.warningsTime[slot] < moGuiMiniPDAsetGet.warningBlinkTime*2 then
				moGuiMiniPDAsetGet.warningsTime[slot] = moGuiMiniPDAsetGet.warningsTime[slot]+1;
			else		
				moGuiMiniPDAsetGet.warningsTime[slot] = 0;
			end;
		end;	
	end;	
end;

function moDrawWarnings.greenHouse(self, slot)	
	local warning = 0;	
	local ratio = moDefault.warningGreenHouseProductivity;
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		warning = 1;
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		warning = 2;
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		warning = 3;
	elseif tonumber(ratio) < 25 then
		warning = 4;
	end;
	--if tonumber(warning) < 2 then warning = 1;end;
	moDrawWarnings.setAll(self, "greenHouse", warning, 1.31, 1.25, slot);
	warning = 0;	
end;

function moDrawWarnings.placeableObjects(self, slot)	
	local warning = 0;	
	local ratio = moDefault.warningPlaceableObjectsProductivity;
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		warning = 1;
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		warning = 2;
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		warning = 3;
	elseif tonumber(ratio) < 25 then
		warning = 4;
	end;
	--if tonumber(warning) < 2 then warning = 1;end;
	moDrawWarnings.setAll(self, "placeableObjects", warning, 1.31, 1.25, slot);
	warning = 0;	
end;

function moDrawWarnings.placeableMods(self, slot)	
	local warning = 0;	
	local ratio = moDefault.warningPlaceableModsProductivity;
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		warning = 1;
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		warning = 2;
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		warning = 3;
	elseif tonumber(ratio) < 25 then
		warning = 4;
	end;
	--if tonumber(warning) < 2 then warning = 1;end;
	moDrawWarnings.setAll(self, "placeableMods", warning, 1.31, 1.25, slot);
	warning = 0;	
end;

function moDrawWarnings.bestPrice(self, slot)
	if moDefault.foundGreatDemand > 0 and slot ~= nil then
		local width = moGuiMiniPDAsetGet.horizontal;
		local height = moGuiMiniPDAsetGet.vertical;		
		local warning = false;
		for k,v in pairs(moStationes) do
			if moStationes[k].greatDemand and moStationes[k].greatDemandDuration == 1 then
				warning = true;
				break;
			end;
		end;
		if warning then
			if moGuiMiniPDAsetGet.warningsTime[slot] < moGuiMiniPDAsetGet.warningBlinkTime then
				moSetGetGui["warningDemand"]:setPosition(moGuiMiniPDAsetGet.posX+(width*slot), moGuiMiniPDAsetGet.posY-(height*slot));
				moSetGetGui["warningDemand"]:render();
				moGuiMiniPDAsetGet.warningsTime[slot] = moGuiMiniPDAsetGet.warningsTime[slot]+1;
			else
				if moGuiMiniPDAsetGet.warningsTime[slot] < moGuiMiniPDAsetGet.warningBlinkTime*2 then
					moGuiMiniPDAsetGet.warningsTime[slot] = moGuiMiniPDAsetGet.warningsTime[slot]+1;
				else		
					moGuiMiniPDAsetGet.warningsTime[slot] = 0;
				end;
			end;
		else
			moSetGetGui["warningDemand"]:setPosition(moGuiMiniPDAsetGet.posX+(width*slot), moGuiMiniPDAsetGet.posY-(height*slot));
			moSetGetGui["warningDemand"]:render();
		end;
	end;	
end;

function moDrawWarnings.animals(self, slot)	
	local warning = 0;	
	local ratio = moDefault.warningAnimalsProductivity;
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		warning = 1;
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		warning = 2;
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		warning = 3;
	elseif tonumber(ratio) < 25 then
		warning = 4;
	end;
	--if tonumber(warning) < 2 then warning = 1;end;
	moDrawWarnings.setAll(self, "animals", warning, 1.31, 1.25, slot);
	warning = 0;	
end;