moSetGetPlaceableMods = {};

---upk mods---
function moSetGetPlaceableMods:setPlaceableModsUpdate(self)	
	moDefaultPlaceable.modsFound = "";
	moDefaultPlaceable.lengthMods = 0;
	--moGuiMiniPDAsetGet.foundObjects[moGuiMiniPDAsetGet.slotOpen] = 0;
	--moGuiMiniPDAsetGet.lengthName[moGuiMiniPDAsetGet.slotOpen] = 0;
	moDefault.warningPlaceableModsProductivity = 100;
	moPlaceableMods = {};	
	function checkPlaceable(xmlModString, objectName, modType, displayName, category)
		if xmlModString ~= nil then		
			setPlaceableMods(self, xmlModString, objectName, modType, displayName, category)				
		end;
	end;
	for a=1, moDefaultPlaceable.searchMods do		
		local splitString = Utils.splitString(",", moDefaultPlaceable.mods[a]);
		local xmlModString = string.lower(moDefault.gameDir.. splitString[2]);
		local objectName = Utils.getNoNil(splitString[3], "factory".. a);
		local category = Utils.getNoNil(splitString[4], "factory");
		local modType = splitString[1];		 
		if modType == "upk" and moDefault.upkMod or modType ~= "upk" then
			--if not string.find(xmlModString, "placeableheaps") then
				checkPlaceable(g_currentMission.placeables[xmlModString], objectName.. "_".. modType, modType, objectName, category);
			--end;
		end;
	end;	
	if moDefaultPlaceable.lengthMods == 0 then
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableMods ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."placeableMods ";end;	
	else
		--moGuiMiniPDAsetGet.foundObjects[moGuiMiniPDAsetGet.slotOpen] = moDefaultPlaceable.lengthMods;
		--moGuiMiniPDAsetGet.lengthName[moGuiMiniPDAsetGet.slotOpen] = moDefault.lengthModsFillName;	
	end;	
end;

function setPlaceableMods(self, xmlModString, objectName, modType, displayName, category)
	moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableMods ", "");	
	if moPlaceableMods[objectName] == nil then		
		moDefaultPlaceable.lengthMods = moDefaultPlaceable.lengthMods+1;		
		moPlaceableMods[objectName] = {};
		moPlaceableMods[objectName].objectName = objectName;
		moPlaceableMods[objectName].modType = modType;
		moPlaceableMods[objectName].length = 0;
		moPlaceableMods[objectName].lengthActive = 0;
		moPlaceableMods[objectName].lengthNotActive = 0;
		if moLanguage.extern[displayName.. moDefault.language] ~= nil then
			moPlaceableMods[objectName].displayName = unpack(moLanguage.extern[displayName.. moDefault.language]);
		else
			moPlaceableMods[objectName].displayName = displayName; --unpack(moLanguage.extern[treeName.. "Tree".. moDefault.language]);
		end;			
		moPlaceableMods[objectName].modName = nil;
		moPlaceableMods[objectName].category = category;
		moPlaceableMods[objectName].outputFillTypes = {};
		moPlaceableMods[objectName].inputFillTypes = {};		
		moPlaceableMods[objectName].productivity = 0;
		moPlaceableMods[objectName].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;	
	local setFirstFillType = false;	
	local setFirstModName = false;
	local fillLevelFound = false;
	local foundHeaps = 0;
	for k, v in pairs(xmlModString) do				
		moPlaceableMods[objectName].length = moPlaceableMods[objectName].length+1;
		local tableMod;
		local modName = nil;
		if moPlaceableMods[objectName].modType == "upk" then
			tableMod = xmlModString[k].base;
			modName = xmlModString[k].base.name;
		elseif moPlaceableMods[objectName].modType == "fs" then
			tableMod = xmlModString[k];	
			modName = "fabrikScript";
		end;		
		--if moPlaceableTrees[treeName].modType == "upk" then
			if not setFirstModName then setFirstModName = true;moPlaceableMods[objectName].modName = modName;end;
			local inputFillTypes, outputFillTypes = moSetGetInputOutputFillTypes:getTables(self, tableMod, modType, modName, "placeableMods", category)			
			if outputFillTypes ~= nil and table.getn(outputFillTypes) > 0 then
				for container,info in pairs(outputFillTypes) do					
					if moPlaceableMods[objectName].outputFillTypes[container] == nil then
						moPlaceableMods[objectName].outputFillTypes[container] = {};						
						moPlaceableMods[objectName].outputFillTypes[container].capacity = outputFillTypes[container][1].capacity;
						moPlaceableMods[objectName].outputFillTypes[container].fillLevel = outputFillTypes[container][1].fillLevel;
						moPlaceableMods[objectName].outputFillTypes[container].bestPrice = outputFillTypes[container][1].pricePerLiter;
						moPlaceableMods[objectName].outputFillTypes[container].fillTypeName = outputFillTypes[container][1].fillTypeName;
						moPlaceableMods[objectName].outputFillTypes[container].lengthFillTypes = outputFillTypes[container][1].lengthFillTypes;
					else
						moPlaceableMods[objectName].outputFillTypes[container].capacity = moPlaceableMods[objectName].outputFillTypes[container].capacity+outputFillTypes[container][1].capacity;
						moPlaceableMods[objectName].outputFillTypes[container].fillLevel = moPlaceableMods[objectName].outputFillTypes[container].fillLevel+outputFillTypes[container][1].fillLevel;
					end;
					if moPlaceableMods[objectName].outputFillTypes[container].fillLevel > 0 then
						moPlaceableMods[objectName].lengthActive = moPlaceableMods[objectName].lengthActive+1;
						fillLevelFound = true;
					else
						moPlaceableMods[objectName].lengthNotActive = moPlaceableMods[objectName].lengthNotActive+1;
					end;					
				end;				
			end;
			if inputFillTypes ~= nil and table.getn(inputFillTypes) > 0 then
				for container,info in pairs(inputFillTypes) do					
					if moPlaceableMods[objectName].inputFillTypes[container+foundHeaps] == nil then
						moPlaceableMods[objectName].inputFillTypes[container+foundHeaps] = {};						
						moPlaceableMods[objectName].inputFillTypes[container+foundHeaps].capacity = inputFillTypes[container][1].capacity;
						moPlaceableMods[objectName].inputFillTypes[container+foundHeaps].fillLevel = inputFillTypes[container][1].fillLevel;
						moPlaceableMods[objectName].inputFillTypes[container+foundHeaps].bestPrice = inputFillTypes[container][1].pricePerLiter;
						moPlaceableMods[objectName].inputFillTypes[container+foundHeaps].fillTypeName = inputFillTypes[container][1].fillTypeName;
						moPlaceableMods[objectName].inputFillTypes[container+foundHeaps].lengthFillTypes = inputFillTypes[container][1].lengthFillTypes;
					else
						moPlaceableMods[objectName].inputFillTypes[container+foundHeaps].capacity = moPlaceableMods[objectName].inputFillTypes[container+foundHeaps].capacity+inputFillTypes[container][1].capacity;
						moPlaceableMods[objectName].inputFillTypes[container+foundHeaps].fillLevel = moPlaceableMods[objectName].inputFillTypes[container+foundHeaps].fillLevel+inputFillTypes[container][1].fillLevel;
					end;
					if moPlaceableMods[objectName].inputFillTypes[container+foundHeaps].fillLevel > 0 then						
						fillLevelFound = true;
					end;					
				end;
			end;
			if category == "heaps" then foundHeaps = foundHeaps+1;end;
		--end;		
	end;
	if moPlaceableMods[objectName].modName == nil then table.remove(moPlaceableMods[objectName]);return;end;	
	moDefaultPlaceable.modsFound = moDefaultPlaceable.modsFound.. objectName.. " ";
	if fillLevelFound and category ~= "stock" and category ~= "heaps" and category ~= "shop" then
		setProductivityColor(self, moPlaceableMods[objectName], moDefault.warningPlaceableModsProductivity);
	end;
	--if moPlaceableTrees[treeName].lengthActive > 0 then
	--	setPlaceableTreeProductivityColor(self, treeName);
	--end;	
end;


function setProductivityColor(self, tableName, warningType)		
	local outputCapacity = 0;
	local outputFillLevel = 0;
	local inputCapacity = 0;
	local inputFillLevel = 0;
	local input = false;
	local output = false;
	local noProductivity = false;
	local ratio = 0;
	if tableName.outputFillTypes ~= nil and table.getn(tableName.outputFillTypes) > 0 then
		for container=1, table.getn(tableName.outputFillTypes) do
			if tableName.outputFillTypes[container] ~= nil and tableName.outputFillTypes[container].fillLevel ~= nil and tableName.outputFillTypes[container].capacity ~= nil then
				outputCapacity = outputCapacity+tableName.outputFillTypes[container].capacity;
				outputFillLevel = outputFillLevel+tableName.outputFillTypes[container].fillLevel;
				output = true;
			end;
		end;
	end;
	if tableName.inputFillTypes ~= nil and table.getn(tableName.inputFillTypes) > 0 then
		for container=1, table.getn(tableName.inputFillTypes) do
			if tableName.inputFillTypes[container] ~= nil and tableName.inputFillTypes[container].fillLevel ~= nil and tableName.inputFillTypes[container].capacity ~= nil then
				inputCapacity = inputCapacity+tableName.inputFillTypes[container].capacity;
				inputFillLevel = inputFillLevel+tableName.inputFillTypes[container].fillLevel;
				input = true;
			end;
		end;
	end;	
	if output then
		ratio = string.format("%0.0f", Utils.getNoNil(outputFillLevel/outputCapacity*100, 0));
		if tonumber(outputFillLevel) >= tonumber(outputCapacity) then			
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
			tableName.productivity = string.format("%0.0f", Utils.getNoNil(0, 0));
			noProductivity = true;
		else
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor0; --moGuiExtras.colors['redDisabled'];
			tableName.productivity = string.format("%0.0f", Utils.getNoNil(100, 0));
		end;
	end;	
	if input and not noProductivity then
		ratio = string.format("%0.0f", Utils.getNoNil(inputFillLevel/inputCapacity*100, 0));
		tableName.productivity = ratio;	
		tableName.productivityColor = moGuiMiniPDAsetGet.warningColor0; --moGuiExtras.colors['green'];
		if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor1; --moGuiExtras.colors['greenDisabled'];
		elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor2; --moGuiExtras.colors['yellow'];
		elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor3; --moGuiExtras.colors['red'];
		elseif tonumber(ratio) < 25 then
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
		end;
	end;
	if tonumber(moDefault.warningPlaceableModsProductivity) >= tonumber(ratio) then 
		moDefault.warningPlaceableModsProductivity = tonumber(ratio);	
	end;
	--if tonumber(warningType) >= tonumber(ratio) then 
	--	warningType = tonumber(ratio);	
	--end;
end;