moSetGetPlaceableTrees = {};


function moSetGetPlaceableTrees:setPlaceableTreesUpdate(self)	
	--if not moDefault.upkMod then
	--	if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableTrees ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."placeableTrees ";end;
	--	return;
	--end;	
	moDefaultPlaceable.treesFound = "";
	--moGuiMiniPDAsetGet.foundObjects[moGuiMiniPDAsetGet.slotOpen] = 0;
	--moGuiMiniPDAsetGet.lengthName[moGuiMiniPDAsetGet.slotOpen] = 0;
	moDefaultPlaceable.lengthTrees = 0;	
	moDefault.warningPlaceableTreesProductivity = 100;
	moPlaceableTrees = {};	
	function checkPlaceableTree(xmlModString, treeName, modType, displayName, category)
		if xmlModString ~= nil then		
			setPlaceableTree(self, xmlModString, treeName, modType, displayName, category)				
		end;
	end;
	--for a=1, moDefaultUpkPlaceable.treesSearch do
	--	local xmlUpkModString = string.lower(moDefault.gameDir.. moDefaultUpkPlaceable.treesMod[a]);
	--	local treeName = moDefaultUpkPlaceable.treesName[a];
	--	checkPlaceableTree(g_currentMission.placeables[xmlUpkModString], treeName);
	--end;
	for a=1, moDefaultPlaceable.searchTrees do
		local splitString = Utils.splitString(",", moDefaultPlaceable.trees[a]);
		local xmlModString = string.lower(moDefault.gameDir.. splitString[2]);
		local treeName = Utils.getNoNil(splitString[3], "trees".. a);
		local category = Utils.getNoNil(splitString[4], "trees");
		local modType = splitString[1];
		if modType == "upk" and moDefault.upkMod or modType ~= "upk" then
			--if not string.find(xmlModString, "placeableheaps") then
				checkPlaceableTree(g_currentMission.placeables[xmlModString], treeName.. "_".. modType, modType, treeName, category);
			--end;
		end;
	end;
	if moDefaultPlaceable.lengthTrees == 0 then
		if not string.find(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableTrees ") then moGuiMiniPDAsetGet.slotNotReadyFound = moGuiMiniPDAsetGet.slotNotReadyFound .."placeableTrees ";end;
	else
		--moGuiMiniPDAsetGet.foundObjects[moGuiMiniPDAsetGet.slotOpen] = moDefaultPlaceable.lengthTrees;
		--moGuiMiniPDAsetGet.lengthName[moGuiMiniPDAsetGet.slotOpen] = moDefault.lengthTreesFillName;
	end;	
end;

function setPlaceableTree(self, xmlModString, treeName, modType, displayName, category)
	moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableTrees ", "");	
	if moPlaceableTrees[treeName] == nil then		
		moDefaultPlaceable.lengthTrees = moDefaultPlaceable.lengthTrees+1;		
		moPlaceableTrees[treeName] = {};
		moPlaceableTrees[treeName].modType = modType;
		moPlaceableTrees[treeName].length = 0;
		moPlaceableTrees[treeName].lengthActive = 0;
		moPlaceableTrees[treeName].lengthNotActive = 0;
		if moLanguage.extern[displayName.. moDefault.language] ~= nil then
			moPlaceableTrees[treeName].displayName = unpack(moLanguage.extern[displayName.. moDefault.language]);
		else
			moPlaceableTrees[treeName].displayName = displayName; --unpack(moLanguage.extern[treeName.. "Tree".. moDefault.language]);
		end;			
		moPlaceableTrees[treeName].modName = nil;
		moPlaceableTrees[treeName].category = category;
		moPlaceableTrees[treeName].outputFillTypes = {};
		moPlaceableTrees[treeName].inputFillTypes = {};		
		moPlaceableTrees[treeName].productivity = 0;
		moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;	
	local setFirstFillType = false;	
	local setFirstModName = false;
	local fillLevelFound = false;
	local foundHeaps = 0;
	for k, v in pairs(xmlModString) do
		moPlaceableTrees[treeName].length = moPlaceableTrees[treeName].length+1;
		local tableMod;
		local modName = nil;
		if moPlaceableTrees[treeName].modType == "upk" then
			tableMod = xmlModString[k].base;
			modName = xmlModString[k].base.name;
		elseif moPlaceableTrees[treeName].modType == "fs" then
			tableMod = xmlModString[k];	
			modName = "fabrikScript";
		end;
			if not setFirstModName then setFirstModName = true;moPlaceableTrees[treeName].modName = modName;end;
			local inputFillTypes, outputFillTypes = moSetGetInputOutputFillTypes:getTables(self, tableMod, modType, modName, "placeableTrees", category)			
			if outputFillTypes ~= nil and table.getn(outputFillTypes) > 0 then				
				for container,info in pairs(outputFillTypes) do					
					if moPlaceableTrees[treeName].outputFillTypes[container] == nil then
						moPlaceableTrees[treeName].outputFillTypes[container] = {};						
						moPlaceableTrees[treeName].outputFillTypes[container].capacity = outputFillTypes[container][1].capacity;
						moPlaceableTrees[treeName].outputFillTypes[container].fillLevel = outputFillTypes[container][1].fillLevel;
						moPlaceableTrees[treeName].outputFillTypes[container].bestPrice = outputFillTypes[container][1].pricePerLiter;
						moPlaceableTrees[treeName].outputFillTypes[container].fillTypeName = outputFillTypes[container][1].fillTypeName;
						moPlaceableTrees[treeName].outputFillTypes[container].lengthFillTypes = outputFillTypes[container][1].lengthFillTypes;
					else
						moPlaceableTrees[treeName].outputFillTypes[container].capacity = moPlaceableTrees[treeName].outputFillTypes[container].capacity+outputFillTypes[container][1].capacity;
						moPlaceableTrees[treeName].outputFillTypes[container].fillLevel = moPlaceableTrees[treeName].outputFillTypes[container].fillLevel+outputFillTypes[container][1].fillLevel;
					end;
					if moPlaceableTrees[treeName].outputFillTypes[container].fillLevel > 0 then
						moPlaceableTrees[treeName].lengthActive = moPlaceableTrees[treeName].lengthActive+1;
						fillLevelFound = true;
					else
						moPlaceableTrees[treeName].lengthNotActive = moPlaceableTrees[treeName].lengthNotActive+1;
					end;					
				end;				
			end;
			if inputFillTypes ~= nil and table.getn(inputFillTypes) > 0 then				
				for container,info in pairs(inputFillTypes) do					
					if moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps] == nil then
						moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps] = {};						
						moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps].capacity = inputFillTypes[container][1].capacity;
						moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps].fillLevel = inputFillTypes[container][1].fillLevel;
						moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps].bestPrice = inputFillTypes[container][1].pricePerLiter;
						moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps].fillTypeName = inputFillTypes[container][1].fillTypeName;
						moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps].lengthFillTypes = inputFillTypes[container][1].lengthFillTypes;
					else
						moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps].capacity = moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps].capacity+inputFillTypes[container][1].capacity;
						moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps].fillLevel = moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps].fillLevel+inputFillTypes[container][1].fillLevel;
					end;
					if moPlaceableTrees[treeName].inputFillTypes[container+foundHeaps].fillLevel > 0 then
						fillLevelFound = true;
					end;					
				end;
			end;
			if category == "heaps" then foundHeaps = foundHeaps+1;end;
		--end;		
	end;
	if moPlaceableTrees[treeName].modName == nil then table.remove(moPlaceableTrees[treeName]);return;end;	
	moDefaultPlaceable.treesFound = moDefaultPlaceable.treesFound.. treeName.. " ";
	if fillLevelFound and category ~= "stock" and category ~= "heaps" and category ~= "shop" then
		setProductivityColor(self, moPlaceableTrees[treeName], moDefault.warningPlaceableTreesProductivity);
	end;
	--if moPlaceableTrees[treeName].lengthActive > 0 then
	--	setPlaceableTreeProductivityColor(self, treeName);
	--end;	
end;


function setProductivityColor(self, tableName, warningType)	
	local outputCapacity = 0;
	local outputFillLevel = 0;
	local inputCapacity = 0;
	local inputFillLevel = 0;
	local input = false;
	local output = false;
	local noProductivity = false;
	local ratio = 0;
	if tableName.outputFillTypes ~= nil and table.getn(tableName.outputFillTypes) > 0 then
		for container=1, table.getn(tableName.outputFillTypes) do
			if tableName.outputFillTypes[container].fillLevel ~= nil and tableName.outputFillTypes[container].capacity ~= nil then
				outputCapacity = outputCapacity+tableName.outputFillTypes[container].capacity;
				outputFillLevel = outputFillLevel+tableName.outputFillTypes[container].fillLevel;
				output = true;
			end;
		end;
	end;
	if tableName.inputFillTypes ~= nil and table.getn(tableName.inputFillTypes) > 0 then
		for container=1, table.getn(tableName.intputFillTypes) do
			if tableName.inputFillTypes[container].fillLevel ~= nil and tableName.inputFillTypes[container].capacity ~= nil then
				inputCapacity = inputCapacity+tableName.inputFillTypes[container].capacity;
				inputFillLevel = inputFillLevel+tableName.inputFillTypes[container].fillLevel;
				input = true;
			end;
		end;
	end;	
	if output then
		ratio = string.format("%0.0f", Utils.getNoNil(outputFillLevel/outputCapacity*100, 0));
		if tonumber(outputFillLevel) >= tonumber(outputCapacity) then			
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
			tableName.productivity = string.format("%0.0f", Utils.getNoNil(0, 0));
			noProductivity = true;
		else
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor0; --moGuiExtras.colors['redDisabled'];
			tableName.productivity = string.format("%0.0f", Utils.getNoNil(100, 0));
		end;
	end;	
	if input and not noProductivity then
		ratio = string.format("%0.0f", Utils.getNoNil(inputFillLevel/inputCapacity*100, 0));
		tableName.productivity = ratio;	
		tableName.productivityColor = moGuiMiniPDAsetGet.warningColor0; --moGuiExtras.colors['green'];
		if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor1; --moGuiExtras.colors['greenDisabled'];
		elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor2; --moGuiExtras.colors['yellow'];
		elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor3; --moGuiExtras.colors['red'];
		elseif tonumber(ratio) < 25 then
			tableName.productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
		end;
	end;
	if tonumber(warningType) >= tonumber(ratio) then 
		warningType = tonumber(ratio);	
	end;
end;

function setUpkPlaceableTreeOld(self, xmlUpkModString, treeName)
	moGuiMiniPDAsetGet.slotNotReadyFound = string.gsub(moGuiMiniPDAsetGet.slotNotReadyFound, "placeableTrees ", "");	
	if moPlaceableTrees[treeName] == nil then
		moDefaultUpkPlaceable.lengthTrees = moDefaultUpkPlaceable.lengthTrees+1;
		moPlaceableTrees[treeName] = {};
		moPlaceableTrees[treeName].lengthActive = 0;
		moPlaceableTrees[treeName].lengthNotActive = 0;
		moPlaceableTrees[treeName].treeName = unpack(moLanguage.extern[treeName.. "Tree".. moDefault.language]);	
		moPlaceableTrees[treeName].modName = nil;
		moPlaceableTrees[treeName].capacity = 0;		
		moPlaceableTrees[treeName].fillLevel = 0;		
		moPlaceableTrees[treeName].fillType = 0;		
		moPlaceableTrees[treeName].fillTypeName = "unknow";
		moPlaceableTrees[treeName].bestPrice = 0;
		moPlaceableTrees[treeName].productivity = 0;
		moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
	local setFirstFillType = false;	
	local setFirstModName = false;
	for k, v in pairs(xmlUpkModString) do
		moPlaceableTrees[treeName].length = moPlaceableTrees[treeName].length+1
		if moPlaceableTrees[treeName].modType == "upk" then
			local inputFillTypes, outputFillTypes = moSetGetUpk:searchUpk(self, xmlUpkModString);
			if not setFirstModName then setFirstModName = true;moPlaceableTrees[treeName].modName = xmlUpkModString[k].base.name;end;			
			moPlaceableTrees[treeName].fillType = xmlUpkModString[k].base:getFillType();			
			
			moPlaceableTrees[treeName].capacity = moPlaceableTrees[treeName].capacity+xmlUpkModString[k].base:getCapacity(moPlaceableTrees[treeName].fillType);
			local fillLevel = xmlUpkModString[k].base:getFillLevel(moPlaceableTrees[treeName].fillType);
			if fillLevel > 0 then 
				moPlaceableTrees[treeName].lengthActive = moPlaceableTrees[treeName].lengthActive+1;
				moPlaceableTrees[treeName].fillLevel = moPlaceableTrees[treeName].fillLevel+fillLevel;				
			else
				moPlaceableTrees[treeName].lengthNotActive = moPlaceableTrees[treeName].lengthNotActive+1;
			end;		
			if fillLevel > 0 and not setFirstFillType then
				setFirstFillType = true;
				--moPlaceableTrees[treeName].fillType = g_currentMission.placeables[xmlUpkModString][k].base:getFillType(moPlaceableTrees[treeName].fillType);
				local desc = Fillable.fillTypeIndexToDesc[moPlaceableTrees[treeName].fillType];
				if desc ~= nil then 
					moPlaceableTrees[treeName].fillTypeName = moFillTypes[desc.index].fruitName;
					moPlaceableTrees[treeName].bestPrice = moFillTypes[desc.index].pricePerLiter*moFillTypes[desc.index].bestPrice*moDefault.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;
				end;			
			end;		
		end;
	end;
	if moPlaceableTrees[treeName].modName == nil then table.remove(moPlaceableTrees[treeName]);return;end;
	moDefaultUpkPlaceable.trees = moDefaultUpkPlaceable.trees.. treeName.. " ";
	if moPlaceableTrees[treeName].lengthActive > 0 then
		setPlaceableTreeProductivityColor(self, treeName);
	end;	
end;

function setPlaceableTreeProductivityColorOld(self, treeName)
	local capacity = moPlaceableTrees[treeName].capacity; --/(moPlaceableTrees[treeName].lengthActive+moPlaceableTrees[treeName].lengthNotActive);
	--capacityt = capacity*moPlaceableTrees[treeName].lengthActive;
	local fillLevel = moPlaceableTrees[treeName].fillLevel;
	local ratio = string.format("%0.0f", Utils.getNoNil(fillLevel/capacity*100, 0));
	moPlaceableTrees[treeName].productivity = ratio;	
	moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor0; --moGuiExtras.colors['green'];
	if tonumber(ratio) <= 90 and tonumber(ratio) >= 75 then
		moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor1; --moGuiExtras.colors['greenDisabled'];
	elseif tonumber(ratio) < 75 and tonumber(ratio) >= 50 then
		moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor2; --moGuiExtras.colors['yellow'];
	elseif tonumber(ratio) < 50 and tonumber(ratio) >= 25 then
		moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor3; --moGuiExtras.colors['red'];
	elseif tonumber(ratio) < 25 then
		moPlaceableTrees[treeName].productivityColor = moGuiMiniPDAsetGet.warningColor4; --moGuiExtras.colors['redDisabled'];
	end;
	if tonumber(moDefault.warningPlaceableTreesProductivity) >= tonumber(ratio) then 
		moDefault.warningPlaceableTreesProductivity = tonumber(ratio);	
	end;
end;